<script setup lang="ts">
import Flex from "@/components/atoms/container/Flex.vue";
import {useRepositoryImportModalStore} from "@/stores/Repository/RepositoryImportModalStore";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";
import RepositorySubmoduleLine from "@/components/organisms/list/Repository/RepositorySubmoduleLine.vue";
import {onMounted, ref, watch} from "vue";
import type {SubmoduleListInterface} from "@/entities/Repository/SubmoduleListInterface";
import type Repository from "@/entities/Repository/Repository";
import {useRouter} from "vue-router";
import FormWithoutButton from "@/components/atoms/form/FormWithoutButton.vue";
import type Submodule from "@/entities/Repository/Submodule";

const repositoryImportModal = useRepositoryImportModalStore();
const repositoryHandler = new RepositoryApiHandler();

const submodules: ref<SubmoduleListInterface> = ref<SubmoduleListInterface>();
const repositoriesToImport: ref<Set<String>> = ref<Set<String>>(new Set<String>());

const router = useRouter();
const formRef = ref();

const replaceRepository = (repository: Repository) => {
  const code = repository.code;

  for (const index in submodules.value.importableSubmodules) {
    const iteratedRepository = submodules.value.importableSubmodules[index];
    const iteratedCode = iteratedRepository.code;
    if (iteratedCode === code) {
      submodules.value.importableSubmodules[index] = repository;
      return;
    }
  }

  if (submodules.value.parentRepository.code === code) {
    submodules.value.parentRepository = repository;
    repositoryImportModal.importedRepository = repository;
  }
}

const onSubmit = () => {
  let promises = [];
  for (const repositoryCode of repositoriesToImport.value) {
    let repositoryToSave = null;
    for (const repository of submodules.value.importableSubmodules) {
      if (repository.code === repositoryCode) {
        repositoryToSave = repository;
        break;
      }
    }

    if (!repositoryToSave) {
      break;
    }

    let promise = null;
    if (repositoryToSave.isAlreadyImported) {
      promise = repositoryHandler.update(repositoryToSave).then(replaceRepository);
    } else {
      promise = repositoryHandler.create(repositoryToSave).then(replaceRepository);
    }

    promises.push(promise);
  }

  Promise.all(promises).then(() => {
    repositoryImportModal.hide();
    router.push('/repository/' + submodules.value.parentRepository.code);
  }).catch(() => {
    repositoryImportModal.submitView = false;
  })
}

watch(() => repositoryImportModal.submitView, (newSubmit: Boolean) => {
  if (newSubmit) {
    formRef?.value?.executeSubmit();
  }
})

onMounted(() => {
  const importedRepository = repositoryImportModal.importedRepository;
  repositoryImportModal.showLoader = true;

  repositoryHandler.getSubmodules(importedRepository)
      .then((submoduleList: SubmoduleListInterface) => {
        submoduleList.importableSubmodules.forEach((repository: Repository) => {
          repository.parentRepositories.forEach((submodule: Submodule) => {
            submodule.child = undefined;
          });
        })

        submodules.value = submoduleList;

        repositoriesToImport.value = new Set<String>([
          ...submoduleList.importableSubmodules.map((repo: Repository) => repo.code),
          submoduleList.parentRepository.code
        ]);
      })
      .finally(() => {
        repositoryImportModal.showLoader = false;
      });
})

</script>

<template>
  <FormWithoutButton :onSubmit="onSubmit" :onFailedSubmit="() => repositoryImportModal.submitView = false"  ref="formRef">
    <Flex class="flex-col gap-content h-full" v-if="submodules">
      <span>Dépôt importé :</span>
      <Flex class="flex-col gap-content overflow-auto">
        <RepositorySubmoduleLine
            :repository="submodules.parentRepository"
            v-if="submodules.parentRepository"
        />
      </Flex>
      <hr/>
      <Flex class="flex-col gap-content overflow-auto" v-if="submodules.importableSubmodules.length > 0">
        <span>Sous modules :</span>
        <RepositorySubmoduleLine
            :key="repository.code"
            :repository="repository" v-for="(repository) of submodules.importableSubmodules"
            :import="repositoriesToImport.has(repository.code)"
            :checkImportCallback="(importValue: Boolean) => {
            const code = repository.code;
            const repoIsImported = repositoriesToImport.has(code);
            if(importValue){
              if(!repoIsImported) {
                repositoriesToImport.add(code);
              }
            } else {
              if(repoIsImported){
                repositoriesToImport.delete(code);
              }
            }
          }"
        />
      </Flex>
      <span v-else>Aucun sous module détecté</span>
      <Flex class="flex-col gap-content overflow-auto" v-if="submodules.unreadableRepositories.length > 0">
        <hr/>
        <span>Sous module non importable :</span>
        <ul>
          <li v-for="(unreadableRepositories) of submodules.unreadableRepositories">
            <span>{{ unreadableRepositories.finalUrl }} ({{ unreadableRepositories.basePath }}) :</span>
            <span>{{ unreadableRepositories.reason }}</span>
          </li>
        </ul>
      </Flex>
    </Flex>
  </FormWithoutButton>
</template>